/*----------------------------------------------------------
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version
2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

The original author of this program is Hin Jang
March 20, 2003
-----------------------------------------------------------*/

// ----------------------------------------------------------
// parser.cpp (a very basic text parser)
// ----------------------------------------------------------

#include "parser.h"

Parser::Parser() { }
Parser::~Parser() { }

int Parser::split(char *source, string fieldSep)
{

  string s(source);
  return split(s, fieldSep);

}

int Parser::split(char *source, char fieldSep)
{

  string a(1, fieldSep);
  string s(source);
  return split(s, a);

}

int Parser::split(string source, char fieldSep)
{

  string a(1, fieldSep);
  return split(source, a);

}

int Parser::split(string source, string fieldSep)
{
  
  int a;
  int b;
  int d = source.length();
  int e = fieldSep.length();

  target.clear();

  // check for valid argument(s)
  //

  if (d < 1 || e < 1) return 0;

  // perform split operation
  //

  a = 0;
  while (a < d) {
      
    b = source.find(fieldSep, a);
    if (b != string::npos) {
	
      if (b-a > 0) target.push_back(source.substr(a, b-a));
      a = b+e;
      
    } else {
      
      if (a > 0) target.push_back(source.substr(a, b-a));
      break;
      
    }
    
  }

  return target.size();

}
