/*----------------------------------------------------------
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version
2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

The original author of this program is Hin Jang
March 20, 2003
-----------------------------------------------------------*/

// ----------------------------------------------------------
// quadTree.cpp
// ----------------------------------------------------------

#include "quadTree.h"

QuadTree::QuadTree()
{

  int i;
  for (i=0; i<4; ++i) {

    c[i] = NULL;

  }

  p = NULL;
  subLevel = 0;

  polygon = new Polygon();

}

QuadTree::~QuadTree()
{

  int i;
  for (i=0; i<4; ++i) {

    if (c[i] != NULL) delete c[i];

  }
  
  delete polygon;

}

void QuadTree::setPoly(Polygon *p)
{

  polygon->v[0] = p->v[0];
  polygon->v[1] = p->v[1];
  polygon->v[2] = p->v[2];
  polygon->v[3] = p->v[3];

  polygon->n[0] = (p->n[0] < 0) ? -p->n[0] : p->n[0];
  polygon->n[0] = (p->n[1] < 0) ? -p->n[1] : p->n[1];
  polygon->n[0] = (p->n[2] < 0) ? -p->n[2] : p->n[2];
  polygon->n[0] = (p->n[3] < 0) ? -p->n[3] : p->n[3];

  polygon->id = p->id;
  polygon->pid = p->pid;

}

